﻿require_relative 'dice.rb'
require_relative 'newyggdice_roll.rb'

def newyggdice(sen)
	res=nil #返り値用変数
	contents=""
	dicesen=""
	res=""
	comment=[]
	con=nil
	con_val=nil
	checkpattern="(?<=\\A|\\s)((\\-|\\+)?(cf[l|g]?[\\+|\\-]?\\d+d\\d*|(?<!cf)(?<![a-z|^\\d])[\\+|\\-]?(\\d+)d(\\d+)|(cf[l|g]?[\\+|\\-]?)?(?<!d)\\d+(?!d)))*+([<>][=]?\\d+)?(?=\\Z|\\s)"
	#先頭に、または、半角スペースの後にダイスの記述があれば
	#puts sen.match(/#{checkpattern}/i)
	if sen.match(/#{checkpattern}/i) then
		if sen.match(/[<>][=]?\d+\Z/i)
			con=sen.slice!(/[<>][=]?\d+\Z/i)
		end
		#スペースごとに分ける
		s=sen.split(nil)
		#分けたものに対してそれぞれダイスかどうかの判定を行う
		dicesen=s.dup #sのコピー、削除などはこっちに適応する
		s.each do |s_block|
			#もしダイスや固定値の形式ではない、あるいは日本語やローマ字がついている
			judge=s_block.match(/#{checkpattern}/i)
			#マッチしなかったらコメントに追加し、ダイスからは消す
			if judge==nil then
				comment.push(s_block)
				dicesen.delete(s_block)
			end
		end
		sen=dicesen.join(" ")
		cmt=comment.join("\s")
		res="#{cmt}\n"
		#頭にcf[l|g]がついていたらすべてcf[l|g]ロールに、そうでなければ個別に判定
		#cfの場合は頭のcfをすべて消す
		if sen.match(/\Acf[^l|^g]/i)
			sen.slice!(0..1)
			res+=cf_diceroll(sen,"cfdice")
		elsif sen.match(/\Acfl/i)
			sen.slice!(0..2)
			res+=cf_diceroll(sen,"cfldice")
		elsif sen.match(/\Acfg/i)
			sen.slice!(0..2)
			res+=cf_diceroll(sen,"cfgdice")
		else
			puts "#{sen} diceroll"	
			res+=diceroll(sen)
		end
	elsif sen.match(/\A(guki|risk|cond|so\d|cont|oq\d+|ra\d+)/i) then
		puts "XXX"
		rolls=sen.scan(/\A(guki|risk|cond|so\d|oq\d+|ra\d+)/i).flatten
		rolls.each do|roll|
			res="" if res==nil
			res+=ather_rolls(roll)
		end
	else
		#ダイスを振る必要がない内容だったのでnilを返す。
		return nil
	end
	puts res
	unless res==nil then
		res.insert(0,"```css\n")
		res.insert(-1,"```")
	end
	return res
end



def cfdice(num)
	dice=Cfdice.new(num)
	dice.cfdice(dice.frag)
	sum=dice.sum+dice.cri_sum-dice.fum_sum
	if dice.cri_sum==0 && dice.fum_sum == 0 then
		puts "#{dice.frag}"
		res="#{dice.sum}[#{dice.frag.join(',')}]"
	else
		res="#{dice.sum+dice.cri_sum-dice.fum_sum}(#{dice.sum}[#{dice.frag.join(',')}]"
	end
	unless dice.cri_sum==0 then
		res+="+#{dice.cri_sum}[#{dice.cri_frag.join(',')}]"
	end
	unless dice.fum_sum==0 then
		res+="-#{dice.fum_sum}[#{dice.fum_frag.join(',')}]"
	end
	unless dice.cri_sum==0 && dice.fum_sum == 0 then
		res+=")"
	end
	return res,sum
end



def cfldice(num)
	dice=Cfldice.new(num)
	dice.cfdice(dice.frag)
	sum=dice.sum+dice.cri_sum-dice.fum_sum
	if dice.cri_sum==0 && dice.fum_sum == 0 then
		res="#{dice.sum}[#{dice.frag.join(',')}]"
	else
		res="#{dice.sum+dice.cri_sum-dice.fum_sum}(#{dice.sum}[#{dice.frag.join(',')}]"
	end
	unless dice.cri_sum==0 then
		res+="+#{dice.cri_sum}[#{dice.cri_frag.join(',')}]"
	end
	unless dice.fum_sum==0 then
		res+="-#{dice.fum_sum}[#{dice.fum_frag.join(',')}]"
	end
	unless dice.cri_sum==0 && dice.fum_sum == 0 then
		res+=")"
	end
	return res,sum
end


def cfgdice(num)
	dice=Cfgdice.new(num)
	dice.cfdice(dice.frag)
	sum=dice.sum+dice.cri_sum-dice.fum_sum
	res="#{sum}(#{dice.sum}[#{dice.frag.join(',')}]"
	unless dice.cri_sum==0 then
		res+="+#{dice.cri_sum}[#{dice.cri_frag.join(',')}]"
	end
	unless dice.fum_sum==0 then
		res+="-#{dice.fum_sum}[#{dice.fum_frag.join(',')}]"
	end
	res+=")"
	return res,sum
end

def nd_dice(num,dim)
	dice=Dice.new(num,dim)
	res="#{dice.sum}[#{dice.frag.join(',')}]"
	return res,dice.sum
end


def ather_rolls(roll)
	if roll =~ /\Ara(\d+)/i
		res=ra($1.to_i)
	end
	if roll.match(/\Acond\z/i)
		res=cond()
	end
	if roll =~/\Aso(\d)/i
		res=so($1.to_i)
	end
	if roll.match(/\Aris?k?\z/i)
		res=ri()
	end
	if roll.match(/\Aguki\z/i)
		res=gk()
	end
	if roll =~ /\Aoq(\d*)/i
		res=oq($1.to_i)
	end
	return res
end


def diceroll(sen)
	cf=[0,0]
	cfl=[0,0]
	cfg=[0,0]
	nd=Array.new
	ndd=Array.new
	ndcode=Array.new
	dicesum=0
	val=0
	#それぞれのダイスまたは固定値に分ける。
	alldices=sen.scan(/[\-|\+]?cf\d+d\d*|[\-|\+]?cfl\d+d\d*|[\-|\+]?cfg\d+d\d*|[\-|\+]?(?<!cf)(?<![a-z|^\d])*\d+d\d+|[\-|\+]?(?<![a-z])\d+(?![a-z])/i)
	alldices.each do|dices| 
		#判定の符号のチェック、符号がなければプラス
		sign=dices.slice!(/[\-|\+]/)
		if sign.nil?
			sign="+"
		end
		#ダイスの種類と符号ごとにダイスの合算を行う、cf3d-cf2d6はそれぞれ振ってから結果を引き算する。cf1d6にはならない。NDはそれぞれダイスロール
		if dices =~ /cf(\d+)d\d*/i #cft
		  cf[0] += $1.to_i if sign == "+"
		  cf[1] += $1.to_i if sign == "-"
		elsif dices =~ /cfl(\d+)d\d*/i #cfl
		  cfl[0] += $1.to_i if sign == "+"
		  cfl[1] += $1.to_i if sign == "-"
		elsif dices =~ /cfg(\d+)d\d*/i #cfg
		  cfg[0] += $1.to_i if sign == "+"
		  cfg[1] += $1.to_i if sign == "-"
		elsif dices =~ /(?<!cf)(?<![a-z|^\d])(\d+)d(\d+)/i #通常ダイス
		  nd_roll = dices.split(/d/)
		  nd.push(nd_roll[0].to_i)
		  ndd.push(nd_roll[1].to_i)
		  ndcode.push("+") if sign == "+"
		  ndcode.push("-") if sign == "-"
		elsif roll_val = dices.match(/(?<![a-z])\d+(?![a-z])/i)[0] #固定値
			  if sign == "+" then
			  	val += roll_val.to_i
			  else
				val += -roll_val.to_i
			  end
		else
		  puts "ダイスの異常を検知しました。"
		  return nil
		end
	end
	dice_rlt=""
	dice_roll_str=""
	unless cf[0]==0 then
		sen,sum=cfdice(cf[0])
		dice_rlt+="+" unless dice_rlt==""
		dice_rlt+=sen
		dicesum+=sum
		dice_roll_str+="+" unless dice_roll_str==""
		dice_roll_str+="cf#{cf[0]}d6"
	end
	unless cf[1]==0 then
		sen,sum=cfdice(cf[1])
		dice_rlt+="-" unless dice_rlt==""
		dice_rlt+=sen
		dicesum-=sum
		dice_roll_str+="-cf#{cf[1]}d6"
	end
	unless cfl[0]==0 then
		sen,sum=cfldice(cfl[0])
		dice_rlt+="+" unless dice_rlt==""
		dice_rlt+=sen
		dicesum+=sum
		dice_roll_str+="+" unless dice_roll_str==""
		dice_roll_str+="cfl#{cfl[0]}d6"
	end
	unless cfl[1]==0 then
		sen,sum=cfldice(cfl[1])
		dice_rlt+="-" unless dice_rlt==""
		dice_rlt+=sen
		dicesum-=sum
		dice_roll_str+="-cfl#{cfl[1]}d6"
	end
	unless cfg[0]==0 then
		sen,sum=cfgdice(cfg[0])
		dice_rlt+="+" unless dice_rlt==""
		dice_rlt+=sen
		dicesum+=sum
		dice_roll_str+="+" unless dice_roll_str==""
		dice_roll_str+="cfg#{cfg[0]}d6"
	end
	unless cfg[1]==0 then
		sen,sum=cfgdice(cfg[1])
		dice_rlt+="-" unless dice_rlt==""
		dice_rlt+=sen
		dicesum-=sum
		dice_roll_str+="-cfg#{cfg[1]}d6"
	end
	unless nd.size==nil
		for i in 0..nd.size-1 do
			sen,sum=nd_dice(nd[i],ndd[i])
			if ndcode[i]=="-" then
				dice_rlt+=ndcode[i]
				dice_rlt+=sen
				dicesum-=sum
				dice_roll_str+="-#{nd[i]}d#{ndd[i]}"
			else
				dice_rlt+=ndcode[i] unless dice_rlt==""
				dice_rlt+=sen
				dicesum+=sum
				dice_roll_str+="+" unless dice_roll_str==""
				dice_roll_str+="#{nd[i]}d#{ndd[i]}"
			end
		end
	end
	unless val==0 then
		dice_rlt+="+" if val>0
		dice_rlt+="#{val}"
	end
	result=dicesum+val
	res="#{dice_roll_str}\sｺﾛｺﾛ...\n#{dice_rlt}\nresult:#{result}"
	res=nil if dice_roll_str.empty?
	return res
end

#6面ダイスを全部cf[lg]にまとめてダイスを振るメソッド
def cf_diceroll(sen,mode)
	dicesum=0 #初期化
	dice_rlt=""
	dice_roll_str=""
    val=0
	atherdice = {}
	result=0
	alldices=sen.scan(/[\-|\+]?\d+d\d*|[\-|\+]?(?<![a-z])\d+(?![a-z])/i).flatten
	alldices.each do |dices|
		if dices =~ /([\+|\-]?\d+)d(\d*)/i
			if $2.to_i == 6 then
				dicesum+=$1.to_i
			else
				if atherdice[$2.to_i].nil?
					atherdice[$2.to_i]=$1.to_i
				else
					atherdice[$2.to_i]+=$1.to_i
				end
			end
		elsif roll_val = dices.match(/(?<![a-z])[\+|\-]?\d+(?![a-z])/i)[0] 
			 val += roll_val.to_i
		end
	end
	unless dicesum==0 then
		dicesen,sum = send"#{mode}",dicesum.abs
		dice_rlt+="-" if dicesum<0
		dice_rlt+=dicesen
		if dicesum<0 then
			result=val-sum
			dice_roll_str+="#{mode.gsub(/dice/,'')}#{dicesum}d6"
		else
			result=val+sum
			dice_roll_str+="#{mode.gsub(/dice/,'')}#{dicesum}d6"
		end
	end
	unless atherdice.empty? then
		atherdice.each do |num,dim|
			puts "dice_rlt=#{dice_rlt}"
			dicesen,sum=nd_dice(dim.to_i.abs,num)
			dice_rlt += "+" if dim.to_i >= 0 && !dice_rlt.empty?
			dice_rlt += "-" if dim.to_i < 0
			puts dice_rlt
			dice_rlt+=dicesen
			if dim<0 then
				result-=sum
				dice_roll_str+="#{dim}d#{num}"
			else
				dice_roll_str+="+" unless dice_roll_str==""
				dice_roll_str+="#{dim}d#{num}"
				result+=sum
			end
		end
	
	end
	unless val==0 then
		dice_rlt+="+" if val>0
		dice_rlt+="#{val}"
		dice_roll_str+="+"  if val>0
		dice_roll_str+="#{val}"
	end
	if result == 0 && atherdice.empty? && dicesum==0 then
		return nil
	end
	res="#{dice_roll_str}\sｺﾛｺﾛ...\n#{dice_rlt}\nresult:#{result}"

end
