﻿require 'discordrb'

@channel_data=Hash.new
@dicebot_arr=Array.new

def dice_comment(event)
	channel_id = event.channel.id
	content= event.content
	user=event.user
	res=nil
	#改行ごとに処理を行う
	ss = content.split(/\n/)
	#ループ開始
	ss.each{|s|
		#行がなくなったらループから抜ける
		#ループごとにシークレットフラグをOFF
		scret = nil
		if s.nil?
			break
	  	end
	  	unless @channel_data[channel_id].nil? then
			#行の頭と末尾の空白文字を削除
			s = s.strip
			#全角アルファベット、数字、スペースを半角に変換
			s = s.tr('０-９ａ-ｚＡ-Ｚ＋－','0-9a-zA-Z+-').tr('　',' ')
			#シークレットダイスの判別
			secret = s.slice!(/\As(?!o)/i)
			#複数回ロールの指定があるか？
			roll_times=s.slice!(/\A\d+r/i)
			#指定がなければロール回数を１に
			if roll_times== nil then
				roll_times=1
			#指定があればロール回数の検証（Max10)
			else
				roll_times.slice!(/r/i)
				if roll_times.to_i>10 then
					@bot.send_message(channel_id,"回数が多すぎます、最大10回までです")
					return
				end
			end
			#複数回処理を行う
			roll_times.to_i.times{
				res=send "#{@channel_data[channel_id]}",s unless s.empty?
				unless res.nil?
					if secret == nil 
						@bot.send_message(channel_id,"#{res}")
					else
						user.pm("#{res}")
						@bot.send_message(channel_id,"```シークレットダイス```")
					end
			  	end
			}
		end
	}
end

def bot_start(event)
	  channel = event.channel.id
	  content= event.content.delete("#{@prefix}s ")
	  dice=@dicebot_arr.index(content)

	  if dice==nil then
			event.send_message("有効なダイスボットではありません")
	  else
	        if @channel_data[channel]==nil then
			    @channel_data[channel]=content
				event.send_message("ダイスボットを起動します\n起動bot:【#{@channel_data[channel]}】") 
				pconfig=@channel_data.to_yaml
				puts pconfig
			    File.open("#{@BaseDir}/data/channel_data.yml",'w'){|f|
					f.write(pconfig)
				}
				res=nil
	        else
				event.send_message("既にdicebotを起動しています\n起動bot:【#{@channel_data[channel]}】")
	        end
	  end
end

def bot_end(event)
	  channel = event.channel.id
	  content= event.content
	  if @channel_data[channel]==nil then
		event.send_message("dicebotは起動していません。")
	  else
		event.send_message("ダイスボットの設定を解除します終了bot【#{@channel_data[channel]}】")
	    @channel_data.delete(channel)
		puts @channel_data
		channel_datas=@channel_data.to_yaml
		File.open("#{@BaseDir}/data/channel_data.yml",'w'){|f|
			f.write(channel_datas)
		}
	  end
	  res=nil
end

def bot_command(event)
	event.user.pm.send_embed do |embed|
		embed.title = "ダイスボットコマンド一覧"
	    embed.colour = 0xFF8000
	    embed.add_field(
	      name: "#{@prefix}help",
	      value: "ヘルプを出します。\nヘルプの後にコマンドを入れると詳細が出ます。",
	      inline: false
	    )
	    embed.add_field(
	      name: "#{@prefix}s:",
	      value: "チャンネルごとにダイスを選択肢て起動します。\n例：【?s yggdice】【?s newyggdice】",
	      inline: false
	    )
	    embed.add_field(
	      name: "#{@prefix}e",
	      value: "チャンネルで起動しているダイスを終了します。",
	      inline: false
	    )
	    embed.add_field(
	      name: "#{@prefix}dice",
	      value: "現在のチャンネルでどのダイスボットが起動しているか確認します。",
	      inline: false
	    )
	    embed.add_field(
	      name: "#{@prefix}save",
	      value: "ログを保存する機能です",
	      inline: false
	    )
	    embed.add_field(
	      name: "#{@prefix}save_tof",
	      value: "シンプルなログを保存する機能です",
	      inline: false
	    )
	    embed.add_field(
	      name: "#{@prefix}log_send",
	      value: "ログの送り先を入力したチャンネルに固定します。",
	      inline: false
	    )
	    embed.add_field(
	      name: "#{@prefix}command",
	      value: "何のコマンドがあるかを確認する機能です。",
	      inline: false
	    )
	    embed.add_field(
	      name: "#{@prefix}shutdown",
	      value: "ダイスボットを終了させます。オーナー登録を行う必要があります。",
	      inline: false
	    )
	end
end

def dicecheck(event)
	channel = event.channel.id
	  if @channel_data[channel]==nil then
		event.send_message("dicebotは起動していません")
	  else
		event.send_message("【#{@channel_data[channel]}】が起動しています")
	  end
end

def bot_ready()
    @bot.game = "ダイスボット"
	puts "dicebot....verX.04"
    puts"dicebot setup start"
	@config=[]

	File.open("#{@BaseDir}/lib/config.rb", mode = "r:utf-8") do |f|
	  f.each_line do |line|
	    @config << line.chomp
	  end
	end
	puts "config_read ok"
	@channel_data=YAML.load(File.new("#{@BaseDir}/data/channel_data.yml"))
    botname=YAML.load(File.new("#{@BaseDir}/data/dicebot.yml"))
    @dicebot_arr=botname.split
    @dicebot_arr.each do |dicebot_arr|
		require"#{@BaseDir}/dice/#{dicebot_arr}"
    	puts "-   #{dicebot_arr}....ready"
    end
    puts "...\n...\n...dicebot ready\ndicebotを起動しました。\n"
end

def bot_send(event)
	channel = event.channel.id
	channel_name = event.channel.name
	if event.user.id == @ownerid
		i=@config.index("@log_send_channel=\"#{@log_send_channel}\"")
		@config[i]="@log_send_channel=\"#{channel}\""
		@log_send_channel=channel
		File.open("#{@BaseDir}/lib/config.rb",'w'){|f|
			@config.each do |config|
				f.write(config+"\n")
			end
		}
 	end
	puts "ログの送り先を#{event.channel.name}にしました。"
	event.respond("ここにログを送信します。")
end