﻿def bot_log(event,start_time_str, end_time_str)
	channel = event.channel
	channel_id = event.channel.id
	times=""
	# 指定された日時を取得
	# 切り出しの終わりの時間(最古のログ）
	start_time = Time.parse(start_time_str).utc
	# 切り出しの初めの時間(最新のログ)、指定がないときは今の時刻を使用する
	unless end_time_str.nil?
	  end_time = Time.parse(end_time_str).utc
	else
	  end_time = Time.now
	end
	#puts start_time,end_time
	# ログをハッシュで記録
	logs=Hash.new{|h,k| h[k]={}} 
	# logs[count][user_id,time,name,content,avatar]  キー1はログの番号、キー2で発言者のユーザーid、発言の時間、発言者の名前（ニックネーム）、発言内容、発言者のアバターをそれぞれ保管する。
	# APIへのリクエストを減らすため、discordからログを取り出す順番が最新のものからになっている。
	# そのため、取り出したときにhtmlに書き込むと新しいもの順に並ぶので、一度保存し別途古いものからhtmlにする。
	#ログ保存用のフォルダを作成
	Dir.mkdir("./logs/#{channel.name}") unless Dir.exist?("./logs/#{channel.name}")
	#ログようアバター保存フォルダの作成
	Dir.mkdir("./logs/#{channel.name}/avaters") unless Dir.exist?("./logs/#{channel.name}/avaters")
	# 最初に処理を行ったdiscrodから取り出したログのidを記録する変数
	logid=nil
	# 保存されたログをカウントする変数
	count=0
	# チャンネル内のメッセージを取得
	# 条件を満たすまではループさせる
	loop do
	  # チャンネルのログを100個づつ取り出して処理する
	  channel.history(100,before_id=logid).each do |message|
	      # メッセージが指定された期間内に投稿されているか判定
	    # 処理済みのメッセージidを更新
	    logid=message.id
	    # メッセージのタイムスタンプをタイム型に直して保存
	    times= Time.parse(message.timestamp.to_s).utc
	    # もしログのタイムスタンプが切り出し開始点よりも古くなったら
		    if times < start_time 
		      	break
		    # もしログのタイムスタンプが切り出し開始点よりも新しくかつ切り出し終了よりも古いなら
		    elsif times > start_time && times < end_time
			      #ログの番号を1増やす。
			      count+=1
			      # 発言者のアバター画像が無ければダウンロード
				  avatar_url = message.author.avatar_url
				  avatar_file = "./logs/#{channel.name}/avaters/" + message.author.id.to_s + '.png'

			    unless File.exist?(avatar_file)
			    File.open(avatar_file, 'wb') do |file|
			      file.write open(avatar_url).read
			    end
		    end
	      # ニックネームがあるかの確認、あればニックネームを使用
		      unless message.author.nick.nil?
		        names=message.author.nick
		      else
		        names=message.author.username
		      end
	      # logsにハッシュとしてログを保存、これは新しい順に並んでいる
	      logs["#{count}"]["user_id"]=message.author.id
	      logs["#{count}"]["time"]=times
	      logs["#{count}"]["name"]=names
		  logcontent=message.content.gsub(/\n+/, '<br>').gsub('```css', '')
	      logs["#{count}"]["content"]=logcontent.gsub(/\A<br>/, '').gsub('```', '')
	      logs["#{count}"]["avatar"]="./avaters/" + message.author.id.to_s + '.png'
	    end
	  end
	  #もしeachを抜けた時点のログのタイムスタンプが切り出し開始点よりも古くなったら
      #puts "#{times.to_time}<#{start_time.to_time}"
	  if times<start_time then
	    # loopを抜ける
	    break
	  end
	  # DiscordAPIの通信制限に引っかからないために3秒待機する。
	  sleep(3)
	end
	#ログをhtmlに書き出し
	# 直前に投稿されたメッセージの発言者を記録する変数
	last_user_id = nil
	# ログの保存先
	log_file = "./logs/#{channel.name}/log_#{start_time.strftime('%Y%m%d')}.html"
	# html用のヘッダーを用意する
	header=''
	header+="<!DOCTYPE html>\n<html>\n<head>\n<meta charset=\"UTF-8\">\n<meta name=\"viewport\" content=\"width=device-width\">\n<title>#{channel.name}</title>\n"
	# スタイルcssもhtml内に埋め込む。
	body=""
	body+="body{\n\tbackground-color:#333333;\n\theight:auto;\n}\n"
	body+=".timestamp{\n\ttext-align:right;\n\tcolor:gray;\n\tfont-size:14px;\n}\n"
	body+=".content{\n\tmin-height:100px;\n\tin-width:800px;\n\tborder-top:solid 1px #ffebcd;\n\tdisplay:block;\n\tbackground-color:#333333;\n\tmargin-top:0px;\n\tpadding:0px;\n\theight:auto;\n}\n"
	body+=".massage{\n\theight:auto;\n\tmax-width: 800px;\n\tmin-width: 240px;\n\tdisplay:block;\n\toverflow: hidden;\n\tmargin-top:10px;\n\tmargin-bottom:10px;\n}\n"
	body+=".image img{\n\tmin-width:40px;\n\tmax-width:40px;\n\tfloat:left;\n\tmargin-top:3px;\n\tmargin-bottom:3px;\n\tpadding:10px;\n\tdisplay:inline-block\n}\n"
	body+=".name{\n\toverflow:hidden;\n\tmargin-top:0px;\n\tmargin-left:6px;\n\tfont-size:18px;\n\tfont-weight:800;\n\ttext-shadow:1px 0 0 black,0 1px 0 black,-1px 0 0 black, 0 -1px 0 black;\n}\n"
	body+=".comment{\n\tmax-width: 800px;\n\tmin-width: 240px;\n\theight:auto;\n\tword-break: break-all;\n\tfont-size:16px;\n\tfont-weight:bold;\n\tmargin-top:1px;\n\tmargin-bottom:1px;\n\tcolor:white;\n\tfont-family:\"メイリオ\";\n}\n"
	title="<h1 style=\"font-size:30px;color:white\">#{channel.name}</h1>\n"
	style="<style>\n#{body}\n</style>\n</head>\n<body>\n#{title}\n"
	# ログファイルを開いてHTMLの開始タグを書き込み
	File.open(log_file, 'w') do |f|
	  f.write("#{header}\n#{style}")
	end

	#logsを古い順の処理するためのループ、countが1になるまでループを繰り返す
	count.downto(1){|num|
	#発言者が前と違う、または前の発言者がいないなら
	id=logs["#{num}"]["user_id"]
	names=logs["#{num}"]["name"]
	contents=logs["#{num}"]["content"]
	avater=logs["#{num}"]["avatar"]
	times=logs["#{num}"]["time"]
	unless last_user_id==id then
	  #最初の発言者でないなら発言を区分けする
	    unless last_user_id.nil?
	      File.open(log_file, 'a') do |f|
	        f.write("\t</span >\n</div>\n")
	      end
	    end
	  #発言者が前と違うときに行う処理
	  File.open(log_file, 'a') do |f|
	    #content 一人分の発言をまとめるコンテナ
	    f.write("<div class=content>\n")
	    #発言者の名前と時刻を入力
	    f.write("\t<span class=name style=\"color:white\">&nbsp;#{names}</span>\n\t<span class=timestamp>&nbsp:#{times}</span>\n")
	    #発言者の画像の表示
	    f.write("\t<div class=image>\n\t\t<img src=\"#{avater}\">\n\t</div>\n")
	    #発言用コンテナ
	    f.write("\t<span class=massage>\n")
	    #発言を追加
	    f.write("\t\t<p class=comment>#{contents}</p>\n")
	  end
	  #前の発言者の更新
	  last_user_id=id
	else #前の発言者と同じなら
	  File.open(log_file, 'a') do |f|
	    #発言だけ追加
	    f.write("\t\t<p class=comment>#{contents}</p>\n")
	  end
	end
	
	}
	#最後の発言とhtmlを閉じる
	File.open(log_file, 'a') do |f|
	  f.write("\t</span >\n</div>\n</body>\n</html>")
	end
	zip="#{channel.name}.zip"


	folder_path = "#{@BaseDir.encode('UTF-8')}/logs/#{channel.name}" # ZIPにするフォルダのパス
	zip_path = "#{@BaseDir.encode('UTF-8')}/logs/#{zip}" # 作成するZIPアーカイブのパス
	#zip_generator = ZipFileGenerator.new(folder_path,zip_path)
	#zip_generator.write
	zipget(folder_path,zip_path)
	if @log_send_channel=="" then
		puts "ログの送り先が設定されていません。\n現在のチャットに送信します"
		@bot.send_file("#{channel_id}", File.open(zip_path, 'r'))
	else
		@bot.send_file("#{@log_send_channel.to_i}", File.open(zip_path, 'r'))
	end
	File.delete(zip_path)
	puts "ログを出力しました。"
end



#どどんとふ風シンプルログ作成

def bot_log_tof(event, start_time_str, end_time_str)
  channel = event.channel
  channel_id = event.channel.id
  # 指定された日時を取得
  # 切り出しの終わりの時間(最古のログ）
  start_time = Time.parse(start_time_str)
  times=""
  # 切り出しの初めの時間(最新のログ)、指定がないときは今の時刻を使用する
  unless end_time_str.nil?
    end_time = Time.parse(end_time_str)
  else
    end_time = Time.now
  end
  # ログをハッシュで記録
  logs=Hash.new{|h,k| h[k]={}} 
  logs_user_id=[]
  # logs[count][user_id,time,name,content,avatar]  キー1はログの番号、キー2で発言者のユーザーid、発言の時間、発言者の名前（ニックネーム）、発言内容、発言者のアバターをそれぞれ保管する。
  # APIへのリクエストを減らすため、discordからログを取り出す順番が最新のものからになっている。
  # そのため、取り出したときにhtmlに書き込むと新しいもの順に並ぶので、一度保存し別途古いものからhtmlにする。
  # 最初に処理を行ったdiscrodから取り出したログのidを記録する変数
  logid=nil
  # 保存されたログをカウントする変数
  count=0
    # チャンネル内のメッセージを取得
  # 条件を満たすまではループさせる
    loop do
    # チャンネルのログを100個づつ取り出して処理する
    channel.history(100,before_id=logid).each do |message|
        # メッセージが指定された期間内に投稿されているか判定
      # 処理済みのメッセージidを更新
      logid=message.id
      # メッセージのタイムスタンプをタイム型に直して保存
      times = message.timestamp.to_time
      # もしログのタイムスタンプが切り出し開始点よりも古くなったら
      if times < start_time 
        break
      # もしログのタイムスタンプが切り出し開始点よりも新しくかつ切り出し終了よりも古いなら
      elsif times > start_time && times < end_time
        #ログの番号を1増やす。
        count+=1
        # ニックネームがあるかの確認、あればニックネームを使用
        unless message.author.nick.nil?
          names=message.author.nick
        else
          names=message.author.name
        end
        # logsにハッシュとしてログを保存、これは新しい順に並んでいる
        logs_user_id.push("#{message.author.id}")
        logs["#{count}"]["user_id"]=message.author.id
        logs["#{count}"]["name"]=names
        logs["#{count}"]["content"]=message.content.gsub('```css', '').gsub('```', '')
      end
    end
    #もしeachを抜けた時点のログのタイムスタンプが切り出し開始点よりも古くなったら
    if times < start_time 
      # loopを抜ける
      break
    end
    # DiscordAPIの通信制限に引っかからないために3秒待機する。
    sleep(3)
  end
  #ログをhtmlに書き出し
  # 直前に投稿されたメッセージの発言者を記録する変数
  last_user_id = nil
  #ログ保存用のフォルダを作成
  Dir.mkdir("./logs/#{channel.name}-tof") unless Dir.exist?("./logs/#{channel.name}-tof")
  # ログの保存先
  log_file = "./logs/#{channel.name}-tof/#{channel.name}_#{start_time.strftime('%Y%m%d')}_simple.html"
  # 色編集用のスタイルを用意する
  #ログのユーザーidから重複する要素を削除する
  logs_user_id=logs_user_id.uniq
  #styleの作成
  style="<!-- 下のカラーコードを変更するとログの色に反映されます -->\n<style>\n"
  logs_user_id.each do |user_id|
    style+="user_id#{user_id} {color:black;}\n"
  end
  style+="</style>\n"
  # html用のヘッダーを用意する
  header=''
  header="<!DOCTYPE html>\n<html>\n<head>\n\t<meta charset=\"UTF-8\">\n\t<meta name=\"viewport\" content=\"width=device-width\">\t<title>#{channel.name}</title>\n</head>\n<body>\n"
  # ログファイルを開いてHTMLの開始タグを書き込み
  File.open(log_file, 'w') do |f|
    f.write("#{header}\n#{style}")
  end
  #logsを古い順の処理するためのループ、countが1になるまでループを繰り返す
  count.downto(1){|num|
  user_id=logs["#{num}"]["user_id"]
  names=logs["#{num}"]["name"]
  contents=logs["#{num}"]["content"]
  File.open(log_file, 'a') do |f|
    f.write("<user_id#{user_id}><b>#{names}</b>&nbsp;&nbsp;#{contents}</user_id#{user_id}><br>\n")
  end
  }
  #htmlを閉じる
  File.open(log_file, 'a') do |f|
    f.write("</body>\n</html>")
  end
  puts("ログを出力しました\nファイル名:#{channel.name}_#{start_time.strftime('%Y%m%d')}_simple.html")
	if @log_send_channel=="" then
		puts "ログの送り先が設定されていません。\n現在のチャットに送信します"
		@bot.send_file("#{channel_id}", File.open(zip_path, 'r'))
	else
  		@bot.send_file("#{@log_send_channel.to_i}", File.open(log_file, 'r'))
	end
	puts "ログを出力しました。"
end